package main

import (
"fmt"
"github.com/golang/protobuf/proto"
"io/ioutil"
"log"
"protoDemo/proto"
)

func write() {
	p := &protoDemo.Person{
		Id:    1234,
		Name:  "Pony",
		Email: "pony@ponycool.com",
		Phones: []*protoDemo.Person_PhoneNumber{
			{Number: "555-4321", Type: protoDemo.Person_HOME},
		},
	}
	book := &protoDemo.AddressBook{}
	book.People = append(book.People, p)
	out, err := proto.Marshal(book)
	if err != nil {
		log.Fatalln("Failed to encode address book:", err)
	}
	if err := ioutil.WriteFile("./test.txt", out, 0644); err != nil {
		log.Fatalln("Failed to write address book:", err)
	}
}
func read() {
	in, err := ioutil.ReadFile("./test.txt")
	if err != nil {
		log.Fatalln("Error reading file:", err)
	}
	book := &protoDemo.AddressBook{}
	if err := proto.Unmarshal(in, book); err != nil {
		log.Fatalln("Failed to parse address book:", err)
	}
	for _, v := range book.People {
		fmt.Println(v.Id, v.Name)
		for _, vv := range v.Phones {
			fmt.Println(vv.Type, vv.Number)
		}
	}
}
func main() {
	write()
	read()
}
